using System;
namespace BTL
{
    public class Ampel3
    {
        // input
        public bool Button; // кнопка пешехода
        
        // output
        public bool R, Y, G; //светофор для машин
        public bool R2, G2; // светофор для пешеходов
        
        //local
        public bool BB; 
        public int B1 = 1;
        public int B1_Prev;
        public int B1_T;
        public bool B1_Pulse = true;
        public int B2 = 1;
        
        public void Process()
        {
            /*Code*/
            R = Y = G = false;
            if (B1_Pulse)
            {
                B1_Prev = B1;
                B1_T = Environment.TickCount;
            }
            switch (B1)
            {
                /*машины едут, пешеходы стоят*/
                case 1: /*S1*/
                {
                    G = true;
                    /*пешеход нажал кнопку или время подошло*/
                    if (BB || (Environment.TickCount - B1_T) > 30000)
                    {
                        /*прошло ли достатоно времени для потока машин*/
                        if ((Environment.TickCount - B1_T) > 10000)
                        {
                            /*машинам желтый*/
                            B1 = 2; /*S2*/
                        }
                    }
                }
                break;
                /*машинам желтый*/
                case 2: /*S2*/
                {
                    Y = true;
                    /*выдержать желтый*/
                    if ((Environment.TickCount - B1_T) > 2000)
                    {
                        /*машины стоят, люди идут*/
                        B1 = 3; /*S3*/
                    }
                }
                break;
                /*машины стоят, люди идут*/
                case 3: /*S3*/
                {
                    R = true;
                    /*пусть люди походят*/
                    if ((Environment.TickCount - B1_T) > 5000)
                    {
                        /*люди стоят, машинам желтый*/
                        B1 = 4; /*S4*/
                    }
                }
                break;
                /*люди стоят, машинам желтый*/
                case 4: /*S4*/
                {
                    Y = true;
                    BB = false;
                    /*коротенькая пауза*/
                    if ((Environment.TickCount - B1_T) > 1000)
                    {
                        /*машины едут, пешеходы стоят*/
                        B1 = 1; /*S1*/
                    }
                }
                break;
            }
            B1_Pulse = B1 != B1_Prev;
            switch (B2)
            {
                case 1: /*S1*/
                {
                    /*пешеход нажал кнопку*/
                    if (Button )
                    {
                        B2 = 2; /*S2*/
                    }
                }
                break;
                case 2: /*S2*/
                {
                    /*пешеход отжал кнопку*/
                    if (!(Button ))
                    {
                        BB = true;
                        B2 = 1; /*S1*/
                    }
                }
                break;
            }
            G2 = R;
            R2 = !G2;
            
            
        }
    }
}